// #define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define all(a) (a).begin(), (a).end()

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        if (i != 0) a[i]+=a[i - 1];
    }
    ll res = 1e18;
    int ci = 0, cj = 0, ck = 0;
    for (int i = 0; i < n;i++) {
        for (int j = i + 1; j < n;j++) {
            for (int k = j + 1; k < n;k++) {
                ll mx = max({a[j - 1] - (i == 0 ? 0 : a[i - 1]), a[k - 1] - a[j - 1], a[n - 1] - a[k - 1] + (i == 0 ? 0 : a[i - 1])});
                ll mn = min({a[j - 1] - (i == 0 ? 0 : a[i - 1]), a[k - 1] - a[j - 1], a[n - 1] - a[k - 1] + (i == 0 ? 0 : a[i - 1])});
                if (res > mx - mn) ci = i, cj = j, ck = k; 
                res = min(res, mx - mn);
            }
        }
    }
    cout << res << '\n' << ci + 1 << ' ' << cj + 1 << ' ' << ck + 1 << endl;
}